<?php
/*********************************************************************************
 * This the taskrabbitclone.com  by Rockers Technology. is paid software. It is released under the terms of 
 * the following BSD License.
 * 
 *  Rockers Technologies (Head Office)
 *    5038,Berthpage Dr
 *    suwanee, GA. Zip Code : 30024
    
 *    E-mail Address : nishu@rockersinfo.com
 * 
 * Copyright  2012-2020 by Rockers Technology , INC a domestic profit corporation has been duly incorporated under
the laws of the state of georiga , USA. www.rockersinfo.com
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 * - Redistributions of source code must retain the above copyright notice, this 
 *   list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice, this 
 *   list of conditions and the following disclaimer in the documentation and/or 
 *   other materials provided with the distribution.

 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 ********************************************************************************/

class Map extends ROCKERS_Controller 
{
	
	/*
	Function name :Map()
	Description :Its Default Constuctor which called when map object initialzie.its load necesary models
	*/
	
	function Map()
	{
		parent::__construct();	
		$this->load->model('map_model');	
		$this->load->model('user_model');
		$this->load->model('worker_model');
		$this->load->model('category_model');	
	}
	
	/*
	Function name :index()
	Parameter :none
	Return : array of all city tasks list
	Use : visitor can see all city tasks in map 
	Description : visitor can search or view the tasks this function which called http://hostname/map
	*/
	
	
	public function index()
	{
				
		$theme = getThemeName();
		$this->template->set_master_template($theme .'/template.php');
		$data['city'] = '';
		$tasklists=$this->map_model->get_city_alltask();
		$data['tasklists']=$tasklists;
		
		$data['theme']=$theme;
		$meta_setting=meta_setting();
		$pageTitle='Recent Tasks in All Cities - '.$meta_setting->title;
		$metaDescription='Recent Tasks in All Cities - '.$meta_setting->meta_description;
		$metaKeyword='Recent Tasks in All Cities - '.$meta_setting->meta_keyword;
		
		$this->template->write('pageTitle',$pageTitle,TRUE);
		$this->template->write('metaDescription',$metaDescription,TRUE);
		$this->template->write('metaKeyword',$metaKeyword,TRUE);
		$this->template->write_view('header',$theme .'/layout/common/header_map',$data,TRUE);
		$this->template->write_view('content_center',$theme .'/layout/map/allcitymap',$data,TRUE);
		$this->template->render();
	}
	
	
	/*
	Function name :in()
	Parameter :$city (available city name)
	Return : array of particular city tasks list
	Use : visitor can see particule city tasks in map 
	Description : visitor can search or view the tasks of one city this function which called http://hostname/map/in/cityname
	*/
	
	public function in($city)
	{
		//$city = str_replace('%20','&nbsp;',$city);
		$city = urldecode($city);
		if($city == ''){ redirect('map'); }	
		
		$theme = getThemeName();
		$this->template->set_master_template($theme .'/template.php');
	
		$tasklists=$this->map_model->get_city_task($city);
		$data['tasklists']=$tasklists;
		$data['city'] = $city;

		$data['theme']=$theme;
		$meta_setting=meta_setting();
		$pageTitle='Recent Tasks in All Cities - '.$meta_setting->title;
		$metaDescription='Recent Tasks in All Cities - '.$meta_setting->meta_description;
		$metaKeyword='Recent Tasks in All Cities - '.$meta_setting->meta_keyword;
		
		$this->template->write('pageTitle',$pageTitle,TRUE);
		$this->template->write('metaDescription',$metaDescription,TRUE);
		$this->template->write('metaKeyword',$metaKeyword,TRUE);
		$this->template->write_view('header',$theme .'/layout/common/header_map',$data,TRUE);
		$this->template->write_view('content_center',$theme .'/layout/map/citymap',$data,TRUE);
		$this->template->render();
	}
	
	
	/*
	Function name :change_city()
	Parameter :none
	Return : none
	Use : visitor can change the city from map page
	Description : visitor can change the map city by clicking on the "Pick City" this function open in pop-up which called http://hostname/map/change_city
	*/
	
	function change_city()
	{
		$theme = getThemeName();
		$this->template->set_master_template($theme . '/template.php');
		$data['theme'] = $theme;
		
	
		
		$this->load->view( $theme . '/layout/map/pick_city', $data);
		
	}
	
	
}

?>