<?php
/*********************************************************************************
 * This the taskrabbitclone.com  by Rockers Technology. is paid software. It is released under the terms of 
 * the following BSD License.
 * 
 *  Rockers Technologies (Head Office)
 *    5038,Berthpage Dr
 *    suwanee, GA. Zip Code : 30024
    
 *    E-mail Address : nishu@rockersinfo.com
 * 
 * Copyright  2012-2020 by Rockers Technology , INC a domestic profit corporation has been duly incorporated under
the laws of the state of georiga , USA. www.rockersinfo.com
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 * - Redistributions of source code must retain the above copyright notice, this 
 *   list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice, this 
 *   list of conditions and the following disclaimer in the documentation and/or 
 *   other materials provided with the distribution.

 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 ********************************************************************************/
class Message extends ROCKERS_Controller 
{
	
	/*
	Function name :Message()
	Description :Its Default Constuctor which called when message object initialzie.its load necesary models
	*/
	
	function Message()
	{
		 parent::__construct();	
		$this->load->model('message_model');
		$this->load->model('user_task_model');
		$this->load->model('task_model');
		$this->load->model('worker_model');
		$this->load->model('user_task_model');
		$this->load->model('search_model');
		$this->load->model('home_model');	
		$this->load->model('user_model');	
	}
	
	
	
	/*
	Function name :index()
	Parameter :none
	Return : none
	Use : redirect to user all messages
	Description : none
	*/
	
	function index()
	{
		redirect('message/allmessage');
	}
	
	
	/*
	Function name :allmessage()
	Parameter :$offset(for paging)
	Return : array of all message
	Use : get user all alret message
	Description : get user all message this function called by http://hostname/message/allmessage
	*/
	
	
	function allmessage($offset=0)
	{
	
		$this->load->library('pagination');
		
		$limit = '10';
		$config['uri_segment']='3';
		$config['base_url'] = site_url('message/allmessage');
		$config['total_rows'] = $this->message_model->get_count_message();
		$config['per_page'] = $limit;
				
		$this->pagination->initialize($config);		
		
		$data['page_link'] = $this->pagination->create_links();
		$data['result'] =$this->message_model->get_all_message($offset,$limit);
		$data['total_rows']=$config['total_rows'];

		
		$data['site_setting']=site_setting();
		$theme = getThemeName();
		$this->template->set_master_template($theme .'/template.php');
		$data['theme']=$theme;
		$meta_setting=meta_setting();
		
		$pageTitle='All Messages for - '.$meta_setting->title;
		$metaDescription='All Messages for - '.$meta_setting->meta_description;
		$metaKeyword='All Messages for - '.$meta_setting->meta_keyword;
		
		$this->template->write('pageTitle',$pageTitle,TRUE);
		$this->template->write('metaDescription',$metaDescription,TRUE);
		$this->template->write('metaKeyword',$metaKeyword,TRUE);
		$this->template->write_view('header',$theme .'/layout/common/header_login',$data,TRUE);
		$this->template->write_view('content_center',$theme .'/layout/message/message',$data,TRUE);
		$this->template->write_view('footer',$theme .'/layout/common/footer',$data,TRUE);
		$this->template->render();
	
	}
	
	
	
	/*
	Function name :read()
	Parameter :$id(message id)
	Return : none
	Use : unread the user message once click on the message link
	Description : all unread message status change by clicking on this function called by http://hostname/message/read/$id
	*/
	
	
	function read($id)
	{
		
		$message = $this->message_model->get_message_detail($id);
		
		$poster = $this->message_model->get_worker_details($message->poster_user_id);

		$data_read=array(
			'is_read'=>1
		) ;
		$this->db->where('message_id',$id);
		if($this->db->update('message',$data_read)){
		
			if(($message->act == 'newoffer') || ($message->act == 'taskfinish') || ($message->act == 'taskcomplete') || ($message->act == 'offeraccept') || ($message->act == 'newmessage') || ($message->act == 'taskassign') ){ 
			
				redirect('tasks/'.$message->task_url_name);
			}
			

			if(($message->act == 'workerwallet') || ($message->act == 'taskcompromise') || ($message->act == 'taskwin') || ($message->act == 'taskloss')){ redirect('wallet'); }
			
			if($message->act == 'taskdispute'){ redirect('dispute/dispute_task/'.$message->task_id); }
			
			if($message->act == 'newconversation'){ redirect('user_task/conversation/'.$poster->worker_id.'/'.$message->task_id); }
			
			if($message->act == 'taskdisputeconversation'){ redirect('dispute/dispute_task/'.$message->task_id); }
			
		
		}
	
	}
}
?>