<?php
/*********************************************************************************
 * This the taskrabbitclone.com  by Rockers Technology. is paid software. It is released under the terms of 
 * the following BSD License.
 * 
 *  Rockers Technologies (Head Office)
 *    5038,Berthpage Dr
 *    suwanee, GA. Zip Code : 30024
    
 *    E-mail Address : nishu@rockersinfo.com
 * 
 * Copyright  2012-2020 by Rockers Technology , INC a domestic profit corporation has been duly incorporated under
the laws of the state of georiga , USA. www.rockersinfo.com
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 * - Redistributions of source code must retain the above copyright notice, this 
 *   list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice, this 
 *   list of conditions and the following disclaimer in the documentation and/or 
 *   other materials provided with the distribution.

 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 ********************************************************************************/
class Suspend extends ROCKERS_Controller 
{
	
	/*
	Function name :Suspend()
	Description :Its Default Constuctor which called when suspend object initialzie.its load necesary models
	*/
	function Suspend()
	{
		parent::__construct();	
		$this->load->model('suspend_model');
		$this->load->model('user_model');	
	}
	
	
	/*
	Function name :index()
	Parameter : $offset(for paging), $msg(custom message)
	Return : none
	Use : when user suspend at time conversation with administrator done from here
	Description : when user suspend at time conversation with administrator done from here which is called by the http://hostname/suspend
	*/
	
	function index($offset=0,$msg='')
	{
		        
		if(!check_user_authentication()) {  redirect('sign_up'); } 
	   
	
	   
	   $theme = getThemeName();
	   $this->template->set_master_template($theme .'/template.php');
	   
		$this->load->library('pagination');

		$limit = '10';
		$config['uri_segment']='3';
		$config['base_url'] = site_url('suspend/index/');
		$config['total_rows'] = $this->suspend_model->get_total_message();
		$config['per_page'] = $limit;
				
		$this->pagination->initialize($config);		
		
		$data['page_link'] = $this->pagination->create_links();
		$data['result'] = $this->suspend_model->get_all_suspend_message($limit,$offset);
		$data['total_rows']=$config['total_rows'];

		$data['error']='';
		$data['comment'] ='';
		
		$data['offset']=$offset;
		
	   $data['site_setting']=site_setting();
	   $data['theme']=$theme;
	   $meta_setting=meta_setting();

	   
	   $pageTitle='Suspend - '.$meta_setting->title;
	   $metaDescription='Suspend - '.$meta_setting->meta_description;
	   $metaKeyword='Suspend - '.$meta_setting->meta_keyword;
	   
	   $this->template->write('pageTitle',$pageTitle,TRUE);
	   $this->template->write('metaDescription',$metaDescription,TRUE);
	   $this->template->write('metaKeyword',$metaKeyword,TRUE);
	   $this->template->write_view('header',$theme .'/layout/suspend/header_suspend',$data,TRUE);
	   $this->template->write_view('content_center',$theme .'/layout/suspend/index',$data,TRUE);
	   $this->template->write_view('footer',$theme .'/layout/common/footer',$data,TRUE);
	   $this->template->render();        
               
       
	
	}
	
	
	/*
	Function name :new_message()
	Parameter : $user_suspend_id(user suspend id)
	Return : none
	Use : add new conversation message from here
	Description : new conversation message from here which is called by the http://hostname/suspend/new_message
	*/
	function new_message($user_suspend_id)
	{
		
		   if(!check_user_authentication()) {  redirect('sign_up'); } 
			   
			  if($user_suspend_id=='')
			  {
			  	redirect('sign_up'); 			  
			  }
            
				
				
				 $this->form_validation->set_rules('comment', 'Comment', 'trim|required');
			  
			   
			   if($this->form_validation->run() == FALSE){
			
					if(validation_errors())
					{
						$data["error"] = validation_errors();
					}else{
						$data["error"] = "";
					}
					
					$data['comment'] = $this->input->post('comment');
					
					

				} else {
			
					$apply=$this->suspend_model->new_comment($user_suspend_id);
					
					
					$data['error']='';
					
				}
				$offset =$this->input->post('offset');;
				
				$data['offset']=$offset;
				
				 $theme = getThemeName();
               $this->template->set_master_template($theme .'/template.php');
			   
			    $this->load->library('pagination');
		
				$limit = '10';
				$config['uri_segment']='3';
				$config['base_url'] = site_url('suspend/index/');
				$config['total_rows'] = $this->suspend_model->get_total_message();
				$config['per_page'] = $limit;
						
				$this->pagination->initialize($config);		
				
				$data['page_link'] = $this->pagination->create_links();
				$data['result'] = $this->suspend_model->get_all_suspend_message($limit,$offset);
				$data['total_rows']=$config['total_rows'];
		
				
               $data['site_setting']=site_setting();
               $data['theme']=$theme;
               $meta_setting=meta_setting();

               
               $pageTitle='Suspend - '.$meta_setting->title;
               $metaDescription='Suspend - '.$meta_setting->meta_description;
               $metaKeyword='Suspend - '.$meta_setting->meta_keyword;
               
               $this->template->write('pageTitle',$pageTitle,TRUE);
               $this->template->write('metaDescription',$metaDescription,TRUE);
               $this->template->write('metaKeyword',$metaKeyword,TRUE);
               $this->template->write_view('header',$theme .'/layout/suspend/header_suspend',$data,TRUE);
               $this->template->write_view('content_center',$theme .'/layout/suspend/index',$data,TRUE);
               $this->template->write_view('footer',$theme .'/layout/common/footer',$data,TRUE);
               $this->template->render();        
               
				
		
	}
	
}

?>